#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/times.h>

static pthread_mutex_t PTalarms_mutex;
static FILE *server=NULL;

int PTalarms_init(void)
{
	if (server != NULL) {
		fprintf(stderr, "PTalarms_init has already been called!\n");
		return -1;
	}
	
	server = popen("PTserver", "w");
	
	if (server == NULL)
	  fprintf(stderr, "PTalarms_init - couldn't popen to server!\n");
	
	setvbuf(server, NULL, _IOLBF, 4096);
	
	return 0;
}

int PTsignal(int signo, void (*func)())
{
	pthread_mutex_lock(&PTalarms_mutex);
	
	/* Register the signal handler for this function */
	signal(signo, func);
	
	fprintf(server, "PTsignal %d %d\n", getpid(), signo);

	pthread_mutex_unlock(&PTalarms_mutex);
	
	return 0;
}

int PTalarm(unsigned int seconds)
{
	pthread_mutex_lock(&PTalarms_mutex);
	fprintf(server, "PTalarm %d %u\n", getpid(), seconds);	
		  
	pthread_mutex_unlock(&PTalarms_mutex);	
	
	return 0;
}
