#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/times.h>
#include "ptalarms.h"

pthread_t t_signo[32];

void thread_sig_alarm(int signo)
{
	printf("Signal caught, signo %d thread_id %ld\n                   set for thread %ld\n", signo, pthread_self(), t_signo[signo-SIGRTMIN]);
}                            

void *threadfunc(void *i)
{
	printf("Thread #%d with id=%ld started.\n",(int)(int*)i, pthread_self());
	t_signo[(int)(int*)i] = pthread_self();
	
	PTsignal((SIGRTMIN+(int)(int*)i), thread_sig_alarm);	
	
	for (;;) {
		PTalarm(1 + (random() % 2));
		pause();		
	}
}

int main()
{
	pthread_t thread_id[SIGRTMAX-SIGRTMIN];
	int i;
	
	printf("Min = %d  Max = %d  Tot num = %d\n", SIGRTMIN, SIGRTMAX, SIGRTMAX-SIGRTMIN);	
	sleep(2);
	
	PTalarms_init();
	
	printf("init done\n");
	
	for (i = 0; i < SIGRTMAX-SIGRTMIN; i++) {
		if (pthread_create(&thread_id[i], NULL, threadfunc, (void*)i)) {
			printf("bad mojo\n");
		}
	}
	
	pthread_exit((void*)1);
	
	return 0;
}

